<h4>Formularios <small>template</small></h4>
<hr>
<form (ngSubmit)="guardar(forma)" #forma="ngForm">

  <div>

    <div
        class="form-group row"
        [ngClass]="{
          'has-danger': (
            (nombre.errors?.required || nombre.errors?.minlength) &&
            nombre.touched)
        }">
      <label class="col-2 col-form-label">Nombre</label>
      <div class="col-8">

        <input class="form-control"
               type="text"
               placeholder="Nombre"
               name="nombre"
               [(ngModel)]="usuario.nombre"
               minlength="3"
               required
               #nombre="ngModel">
        <div
               *ngIf="nombre.errors?.required && nombre.touched"
               class="form-control-feedback">
          Este campo es requerido.
        </div>
        <div
               *ngIf="nombre.errors?.minlength && nombre.touched"
               class="form-control-feedback">
          Este campo debe tener por lo menos 
          {{ nombre.errors.minlength.requiredLength }} caracteres, pero 
          tiene {{ nombre.errors.minlength.actualLength }} caracteres actualmente.
        </div>
      </div>
    </div>

    <div
        class="form-group row"
        [ngClass]="{
          'has-danger': (
            (apellido.errors?.required || apellido.errors?.minlength) &&
            apellido.touched)
        }">
      <label class="col-2 col-form-label">Apellido</label>
      <div class="col-8">

        <input class="form-control"
               type="text"
               placeholder="Apellido"
               name="apellido"
               [(ngModel)]="usuario.apellido"
               minlength="3"
               required
               #apellido="ngModel">
        <div
               *ngIf="apellido.errors?.required && apellido.touched"
               class="form-control-feedback">
          Este campo es requerido.
        </div>
        <div
               *ngIf="apellido.errors?.minlength && apellido.touched"
               class="form-control-feedback">
          Este campo debe tener por lo menos 
          {{ apellido.errors.minlength.requiredLength }} caracteres, pero 
          tiene {{ apellido.errors.minlength.actualLength }} caracteres actualmente.
        </div>
      </div>
    </div>

  </div>

  <div
      class="form-group row"
      [ngClass]="{
        'has-danger': (
          (email.errors?.required ||
          email.errors?.minlength ||
          email.errors?.pattern) &&
          email.touched)
      }">
    <label class="col-2 col-form-label">Correo</label>
    <div class="col-md-8">

      <input class="form-control"
             type="email"
             placeholder="Correo electrónico"
             name="email"
             [(ngModel)]="usuario.correo"
             minlength="3"
             required
             pattern="[a-z0-9._%+-]+@[a-z0-9.-]+\.[a-z]{2,3}$"
             #email="ngModel">
      <div
             *ngIf="email.errors?.required && email.touched"
             class="form-control-feedback">
        Este campo es requerido.
      </div>
      <div
             *ngIf="email.errors?.minlength && email.touched"
             class="form-control-feedback">
        Este campo debe tener por lo menos 
        {{ email.errors.minlength.requiredLength }} caracteres, pero 
        tiene {{ email.errors.minlength.actualLength }} caracteres actualmente.
      </div>
      <div
             *ngIf="email.errors?.pattern && email.touched"
             class="form-control-feedback">
        Este campo no es un correo valido.
      </div>
    </div>
  </div>

  <!-- <div
      class="form-group row"
      [ngClass]="{
        'has-danger': (
          (nombre.errors?.required || nombre.errors?.minlength) &&
          nombre.touched)
      }"> -->
  <div class="form-group row">
    <label class="col-2 col-form-label">Pais</label>
    <div class="col-8">
      <select
             [(ngModel)]="usuario.pais"
             name="pais" class="form-control">
        <option value="">Seleccione un Pais</option>
        <option
          *ngFor="let pais of paises"
          [value]="pais.codigo"> {{ pais.nombre }} </option>
      </select>
    </div>
  </div>

  <div class="form-group row">
    <label class="col-2 col-form-label">Sexo</label>
    <div class="col-8">
      <label
          *ngFor="let s of sexos"
          class="custom-control custom-radio">
        <input
            [(ngModel)]="usuario.sexo"
            [value]="s"
            type="radio"
            name="sexo"
            class="custom-control-input">
        <span class="custom-control-indicator"></span>
        <span class="custom-control-description">
          {{ s }}
        </span>
      </label>
      <!-- <label class="custom-control custom-radio">
        <input
            [(ngModel)]="usuario.sexo"
            value="Mujer"
            type="radio"
            name="sexo"
            class="custom-control-input">
        <span class="custom-control-indicator"></span>
        <span class="custom-control-description">Mujer</span>
      </label> -->
    </div>
  </div>

  <div class="form-group row">
    <label class="col-2 col-form-label">Acepta</label>
    <div class="col-8">
      <label class="custom-control custom-checkbox">
        <input
            [(ngModel)]="usuario.acepta"
            name="acepta"
            type="checkbox" class="custom-control-input"
            required>
        <span class="custom-control-indicator"></span>
        <span class="custom-control-description">Acepta los terminos y condiciones</span>
      </label>
    </div>
  </div>

  <div class="form-group row">
    <label class="col-2 col-form-label">&nbsp;</label>
    <div class="input-group col-md-8">
      <button
        [disabled]="!forma.valid"
        type="submit"
        class="btn btn-outline-primary">
        Guardar
      </button>
    </div>
  </div>

</form>

<pre>
  {{ usuario | json }}
</pre>